diff --git a/game/client/.gitignore b/game/client/.gitignore
index 2959db291..4f654f768 100644
--- a/game/client/.gitignore
+++ b/game/client/.gitignore
@@ -1,2 +1,3 @@
 build
+dumpTextures
 logs
\ No newline at end of file
diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index faee365fa..cde808703 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -13,7 +13,7 @@ val include: Configuration by configurations.creating
 
 repositories {
     mavenCentral()
-    maven("https://libraries.minecraft.net/")
+    maven("https://libraries.minecraft.net")
     maven("https://jitpack.io")
     ivy {
         url = uri("https://piston-data.mojang.com")
@@ -54,6 +54,9 @@ dependencies {
 
     implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.3")?.let { include(it) }
 
+    implementation("org.apache-extras.beanshell:bsh:2.0b6")?.let { include(it) }
+    implementation("com.deepoove:codehighlight:1.0.3")?.let { include(it) }
+
     implementation(libs.bundles.lwjgl)
     for (lib in libs.bundles.lwjgl.get()) {
         runtimeOnly(lib.group, lib.name, classifier = rootProject.ext["lwjglNatives"].toString())
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 3cec32889..13500a906 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -15,6 +15,8 @@ import java.util.*;
 
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.client.console.LogMessageReceiver;
+import net.minecraft.client.console.shell.BindManager;
 import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.enums.EnumGPUVendor;
@@ -259,7 +261,7 @@ public class Minecraft
     public ScaledResolution resolution;
     public boolean fullbright = false;
     public Renderer renderer;
-    public ControllerInput controllerInput;
+    public @Nullable ControllerInput controllerInput;
     public final MouseInput mouseInput = new MouseInput(this);
     public InputType inputType = InputType.KEYBOARD;
     public final ScreenshotHelper screenshotHelper = new ScreenshotHelper(this);
@@ -453,6 +455,9 @@ public class Minecraft
         ImageIO.setUseCache(false); // Speeds up boot time
 		mcDataDir = getMinecraftDir();
 
+        // Initialize LogMessageReceiver to capture output
+        LogMessageReceiver.init();
+
         Holidays.initialize();
 
         // Manually initialize blocks and items
@@ -1571,8 +1576,13 @@ public class Minecraft
         		if(Keyboard.getEventKeyState() && gameSettings.showFrameTimes.value && DebugRender.keyPressed(Keyboard.getEventKey())) {
         			continue;
         		}
-            	
-            	
+
+                final @Nullable Runnable scriptBindAction = BindManager.getInstance().getActionForKey(Keyboard.getEventKey());
+                if (scriptBindAction != null) {
+                    scriptBindAction.run();
+                    continue;
+                }
+
                 boolean shift = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
                 //Fix your keyboard Mak you broke the overlay toggle
                 boolean control = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) /* || Keyboard.isKeyDown(Keyboard.KEY_F4)*/;
@@ -1720,6 +1730,10 @@ public class Minecraft
                         {
                             mouseInput.releaseCursor();
                         }
+                        else if (gameSettings.keyShowConsole.isPressEvent() && gameSettings.developerMode.value)
+                        {
+                            displayScreen(new ScreenConsole(this.currentScreen));
+                        }
                         else if (Keyboard.getEventKey() == Keyboard.KEY_ESCAPE)
                         {
                             displayInGameMenu();
@@ -2165,32 +2179,8 @@ public class Minecraft
                 thePlayer.displayGuidebookScreen();
             }
         }else {
-            Screen currentScreen = this.currentScreen;
-            if(controller.buttonB.pressedThisFrame()) {
-                currentScreen.keyPressed((char)0, Keyboard.KEY_BACK, -1, -1);
-            }
-            if(controller.buttonStart.pressedThisFrame()) {
-                currentScreen.keyPressed((char)0, Keyboard.KEY_ESCAPE, -1, -1);
-            }
-            if(controller.buttonA.pressedThisFrame()) {
-                currentScreen.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
-            }
-            if(controller.buttonA.releasedThisFrame()) {
-                currentScreen.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
-            }
-            if(controller.buttonY.pressedThisFrame()) {
-                currentScreen.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 1);
-            }
-            if(controller.buttonY.releasedThisFrame()) {
-                currentScreen.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 1);
-            }
-            if(controller.buttonX.pressedThisFrame()) {
-                currentScreen.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 10);
-            }
-
-            //ContainerInventory Controls
             try{
-                currentScreen.controllerInput(controller);
+                this.currentScreen.controllerInput(controller);
             }catch (Exception e) {
                 LOGGER.error("Exception occurred while running gui specific controller actions!", e);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/console/LogMessage.java b/game/client/src/main/java/net/minecraft/client/console/LogMessage.java
new file mode 100644
index 000000000..6cddd96d7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/LogMessage.java
@@ -0,0 +1,39 @@
+package net.minecraft.client.console;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public final class LogMessage {
+    public enum Level {
+        ERROR,
+        WARN,
+        INFO,
+        DEBUG,
+        TRACE
+    }
+
+    private final @Nullable Level level;
+    private final @NotNull String message;
+
+    public LogMessage(@NotNull String message) {
+        @Nullable Level level = null;
+        for (final @NotNull Level l : Level.values()) {
+            final @NotNull String prefix = l + ": ";
+            if (message.startsWith(prefix)) {
+                level = l;
+                message = message.substring(prefix.length());
+                break;
+            }
+        }
+        this.level = level;
+        this.message = message;
+    }
+
+    public @Nullable Level getLevel() {
+        return this.level;
+    }
+
+    public @NotNull String getMessage() {
+        return this.message;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/LogMessageReceiver.java b/game/client/src/main/java/net/minecraft/client/console/LogMessageReceiver.java
new file mode 100644
index 000000000..e6f6a13ae
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/LogMessageReceiver.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.console;
+
+import com.mojang.logging.LogQueues;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.function.Consumer;
+
+public abstract class LogMessageReceiver {
+    private static final int MESSAGE_CACHE_SIZE = 1000;
+    private static final @NotNull List<@NotNull LogMessage> MESSAGE_QUEUE = new ArrayList<>(MESSAGE_CACHE_SIZE);
+    private static final @NotNull List<@NotNull Consumer<@NotNull LogMessage>> CALLBACKS = new ArrayList<>();
+
+    public static void init() {
+        final @NotNull Thread logAppenderThread = new Thread(() -> {
+            do {
+                final @Nullable String logEvent = LogQueues.getNextLogEvent("IngameConsole");
+                if (logEvent != null) {
+                    append(logEvent);
+                } else {
+                    break;
+                }
+            } while (true);
+        });
+        logAppenderThread.setDaemon(true);
+        logAppenderThread.start();
+    }
+
+    public static void append(final @NotNull String message) {
+        final @NotNull LogMessage logMessage = new LogMessage(message);
+        MESSAGE_QUEUE.add(logMessage);
+        if (MESSAGE_QUEUE.size() > 1000) {
+            MESSAGE_QUEUE.remove(0);
+        }
+        for (@NotNull Consumer<@NotNull LogMessage> consumer : CALLBACKS) {
+            consumer.accept(logMessage);
+        }
+    }
+
+    public static void addCallback(final @NotNull Consumer<@NotNull LogMessage> callback) {
+        CALLBACKS.add(callback);
+    }
+
+    public static @NotNull List<@NotNull LogMessage> getQueue() {
+        return MESSAGE_QUEUE;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java b/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java
new file mode 100644
index 000000000..aed2a30c3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.console.shell;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Map;
+
+public final class BindManager {
+    private static final @NotNull BindManager INSTANCE = new BindManager();
+    public static @NotNull BindManager getInstance() {
+        return INSTANCE;
+    }
+
+    private @NotNull Map<@NotNull Integer, @NotNull Runnable> keyToRunnableMap = new HashMap<>();
+
+    public @NotNull Collection<@NotNull Integer> getKeys() {
+        return this.keyToRunnableMap.keySet();
+    }
+
+    public @Nullable Runnable getActionForKey(final int key) {
+        if (this.keyToRunnableMap.containsKey(key)) {
+            return this.keyToRunnableMap.get(key);
+        }
+
+        return null;
+    }
+
+    public void bindKeyToAction(final int key, final @Nullable Runnable action) {
+        if (action == null) {
+            this.keyToRunnableMap.remove(key);
+        } else {
+            this.keyToRunnableMap.put(key, action);
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/RawOutputWrapper.java b/game/client/src/main/java/net/minecraft/client/console/shell/RawOutputWrapper.java
new file mode 100644
index 000000000..55157a9d5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/RawOutputWrapper.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.console.shell;
+
+public class RawOutputWrapper {
+    public String value;
+
+    public RawOutputWrapper(String value) {
+        this.value = value;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/RuntimeExecutor.java b/game/client/src/main/java/net/minecraft/client/console/shell/RuntimeExecutor.java
new file mode 100644
index 000000000..bceb92777
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/RuntimeExecutor.java
@@ -0,0 +1,155 @@
+package net.minecraft.client.console.shell;
+
+import bsh.EvalError;
+import bsh.Interpreter;
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.console.shell.commands.reloadScripts;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+public final class RuntimeExecutor {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private final @NotNull Interpreter interpreter;
+
+    public RuntimeExecutor() {
+        this.interpreter = new Interpreter();
+
+        reloadScripts.invoke(this.interpreter, null);
+    }
+
+    public @NotNull String runCode(final @NotNull String line) {
+        StringBuilder sb = new StringBuilder();
+
+        if (line.equalsIgnoreCase("help") || line.equals("?")) {
+            sb
+                .append(TextFormatting.WHITE)
+                .append("[ Better than Adventure! Developer Console ]\n")
+                .append(TextFormatting.LIGHT_GRAY)
+                .append("This is a BeanShell-powered developer shell for Better than Adventure!, ")
+                .append("which allows you to view and modify most of the game's objects through ")
+                .append("interpreted Java code.\n")
+                .append(TextFormatting.YELLOW)
+                .append("If you don't know what any of this means, it's probably best to close this ")
+                .append("window.\n")
+                .append("\n")
+                .append("Along with BeanShell's default command set, this shell provides some extra ")
+                .append("commands to make interfacing with BTA! easier.\n")
+
+                // mc()
+                .append(" - ")
+                .append(TextFormatting.WHITE)
+                .append("Minecraft ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("mc")
+                .append(TextFormatting.WHITE)
+                .append("();\n")
+                .append("       ")
+                .append("Fetches the current Minecraft object.\n")
+
+                // fields()
+                .append(" - ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("fields")
+                .append(TextFormatting.WHITE)
+                .append("(Object o);\n")
+                .append("   ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("fields")
+                .append(TextFormatting.WHITE)
+                .append("(Class<?> clazz);\n")
+                .append("       ")
+                .append("Displays all the fields of a given object or class.\n")
+
+                // methods()
+                .append(" - ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("methods")
+                .append(TextFormatting.WHITE)
+                .append("(Object o);\n")
+                .append("   ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("methods")
+                .append(TextFormatting.WHITE)
+                .append("(Class<?> clazz);\n")
+                .append("       ")
+                .append("Displays all the methods of a given object or class.\n")
+
+                // logEnable()
+                .append(" - ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("logEnable")
+                .append(TextFormatting.WHITE)
+                .append("(String category);\n")
+                .append("       ")
+                .append("Enables a given logging category.\n")
+
+                // logDisable()
+                .append(" - ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("logDisable")
+                .append(TextFormatting.WHITE)
+                .append("(String category);\n")
+                .append("       ")
+                .append("Disables a given logging category.\n")
+
+                // logList()
+                .append(" - ")
+                .append(TextFormatting.ORANGE)
+                .append("void ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append("logList")
+                .append(TextFormatting.WHITE)
+                .append("();\n")
+                .append("       ")
+                .append("Displays all known logging categories.\n")
+            ;
+
+            return sb.toString();
+        }
+
+        try {
+            final @Nullable Object result = this.interpreter.eval(line);
+            sb.append(TextFormatting.WHITE);
+            if (result == null) {
+                sb.append(TextFormatting.ORANGE).append("null");
+            } else if (result instanceof RawOutputWrapper) {
+                sb.append(((RawOutputWrapper) result).value);
+            } else if (result.getClass().isPrimitive()) {
+                sb.append(TextFormatting.LIGHT_BLUE).append(result);
+            } else if (result instanceof String) {
+                sb.append(TextFormatting.GREEN).append("\"").append(result).append("\"");
+            } else {
+                sb.append(result);
+            }
+        } catch (final @NotNull EvalError e) {
+            sb
+                .append(TextFormatting.RED)
+                .append(e);
+        } catch (final @NotNull Throwable t) {
+            sb
+                .append(TextFormatting.RED)
+                .append("Caught exception: ")
+                .append(t);
+        }
+
+        return sb.toString();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java b/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java
new file mode 100644
index 000000000..0f76393c2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java
@@ -0,0 +1,115 @@
+package net.minecraft.client.console.shell.commands;
+
+import bsh.CallStack;
+import bsh.ClassIdentifier;
+import bsh.Interpreter;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.Nullable;
+
+import java.lang.reflect.Field;
+import java.lang.reflect.Modifier;
+
+public class fields {
+    public static RawOutputWrapper invoke(Interpreter env, CallStack callstack, Object o) {
+        final Class<?> clazz = o.getClass();
+        StringBuilder sb = new StringBuilder();
+        Field[] fields = clazz.getFields();
+        for (Field field : fields) {
+            sb
+                .append(TextFormatting.WHITE)
+                .append("    ")
+                .append(TextFormatting.ORANGE)
+                .append(Modifier.toString(field.getModifiers()))
+                .append(" ");
+            if (field.getType().isPrimitive()) {
+                sb
+                    .append(TextFormatting.ORANGE);
+            } else {
+                sb
+                    .append(TextFormatting.WHITE);
+            }
+            sb
+                .append(field.getType().getSimpleName())
+                .append(" ")
+                .append(TextFormatting.PINK)
+                .append(field.getName())
+                .append(TextFormatting.WHITE)
+                .append(" = ");
+            appendObject(field, o, sb);
+            sb
+                .append(TextFormatting.WHITE)
+                .append(";\n");
+        }
+        return new RawOutputWrapper(sb.toString());
+    }
+
+    public static RawOutputWrapper invoke(Interpreter env, CallStack callstack, ClassIdentifier clazz) {
+        StringBuilder sb = new StringBuilder();
+        if (clazz.getTargetClass() != null) {
+            Field[] fields = clazz.getTargetClass().getFields();
+            for (Field field : fields) {
+                sb
+                    .append(TextFormatting.WHITE)
+                    .append("    ")
+                    .append(TextFormatting.ORANGE)
+                    .append(Modifier.toString(field.getModifiers()))
+                    .append(" ")
+                    .append(TextFormatting.WHITE)
+                    .append(field.getType().getSimpleName())
+                    .append(" ")
+                    .append(TextFormatting.PINK)
+                    .append(field.getName());
+                if (Modifier.isStatic(field.getModifiers())) {
+                    sb
+                        .append(TextFormatting.WHITE)
+                        .append(" = ");
+                    appendObject(field, null, sb);
+                }
+                sb
+                    .append(TextFormatting.WHITE)
+                    .append(";\n");
+            }
+            return new RawOutputWrapper(sb.toString());
+        } else {
+            return null;
+        }
+    }
+
+    private static void appendObject(Field field, Object o, StringBuilder sb) {
+        try {
+            final @Nullable Object v = field.get(null);
+            if (o instanceof String) {
+                sb
+                    .append(TextFormatting.LIGHT_BLUE)
+                    .append("\"")
+                    .append(v)
+                    .append("\"");
+            } else if (!field.getType().isPrimitive() && v != null) {
+                if (v.getClass().getMethod("toString").getDeclaringClass() == Object.class) {
+                    sb
+                        .append(TextFormatting.ORANGE)
+                        .append("new ")
+                        .append(TextFormatting.WHITE)
+                        .append(v.getClass().getSimpleName())
+                        .append("()");
+                } else {
+                    sb
+                        .append(TextFormatting.LIGHT_BLUE)
+                        .append("[")
+                        .append(v)
+                        .append("]");
+                }
+            } else {
+                sb
+                    .append(TextFormatting.LIGHT_BLUE)
+                    .append(v);
+            }
+        } catch (IllegalAccessException e) {
+            sb
+                .append("?!");
+        } catch (NoSuchMethodException e) {
+            // This literally cannot happen
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/commands/methods.java b/game/client/src/main/java/net/minecraft/client/console/shell/commands/methods.java
new file mode 100644
index 000000000..b58cd8a3e
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/commands/methods.java
@@ -0,0 +1,84 @@
+package net.minecraft.client.console.shell.commands;
+
+import bsh.CallStack;
+import bsh.ClassIdentifier;
+import bsh.Interpreter;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+import net.minecraft.core.net.command.TextFormatting;
+
+import java.lang.reflect.Method;
+import java.lang.reflect.Modifier;
+import java.lang.reflect.Parameter;
+
+public class methods {
+    public static RawOutputWrapper invoke(Interpreter env, CallStack callstack, Object o) {
+        return inner(o.getClass());
+    }
+
+    public static RawOutputWrapper invoke(Interpreter env, CallStack callstack, ClassIdentifier clazz) {
+        return inner(clazz.getTargetClass());
+    }
+
+    private static RawOutputWrapper inner(Class<?> clazz) {
+        if (clazz == null) {
+            return null;
+        }
+
+        StringBuilder sb = new StringBuilder();
+        Method[] methods = clazz.getMethods();
+        for (Method method : methods) {
+            Class<?> returnType = method.getReturnType();
+            sb
+                .append(TextFormatting.WHITE)
+                .append("    ")
+                .append(TextFormatting.ORANGE)
+                .append(Modifier.toString(method.getModifiers()))
+                .append(" ");
+            if (returnType.isPrimitive()) {
+                sb
+                    .append(TextFormatting.ORANGE);
+            } else {
+                sb
+                    .append(TextFormatting.WHITE);
+            }
+            sb
+                .append(returnType.getSimpleName())
+                .append(" ")
+                .append(TextFormatting.LIGHT_BLUE)
+                .append(method.getName())
+                .append(TextFormatting.WHITE)
+                .append("(");
+            Parameter[] parameters = method.getParameters();
+            for (int i = 0; i < method.getParameterCount(); i++) {
+                Parameter parameter = parameters[i];
+                String modifierString = Modifier.toString(parameter.getModifiers());
+                if (!modifierString.isEmpty()) {
+                    sb
+                        .append(TextFormatting.ORANGE)
+                        .append(modifierString)
+                        .append(" ");
+                }
+                if (parameter.getType().isPrimitive()) {
+                    sb
+                        .append(TextFormatting.ORANGE);
+                } else {
+                    sb
+                        .append(TextFormatting.WHITE);
+                }
+                sb
+                    .append(parameter.getType().getSimpleName())
+                    .append(" ")
+                    .append(TextFormatting.WHITE)
+                    .append(parameter.getName());
+                if (i < parameters.length - 1) {
+                    sb
+                        .append(", ");
+                }
+            }
+            sb
+                .append(TextFormatting.WHITE)
+                .append(");\n");
+        }
+        return new RawOutputWrapper(sb.toString());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/commands/reloadScripts.java b/game/client/src/main/java/net/minecraft/client/console/shell/commands/reloadScripts.java
new file mode 100644
index 000000000..baa950179
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/commands/reloadScripts.java
@@ -0,0 +1,118 @@
+package net.minecraft.client.console.shell.commands;
+
+import bsh.CallStack;
+import bsh.Interpreter;
+import com.mojang.logging.CategorizedLogger;
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.console.shell.RawOutputWrapper;
+import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.core.net.command.TextFormatting;
+
+import java.io.File;
+import java.net.URI;
+import java.net.URL;
+import java.nio.file.*;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Iterator;
+import java.util.List;
+import java.util.stream.Stream;
+
+public class reloadScripts {
+    private static final CategorizedLogger LOGGER = LogUtils.getLogger();
+
+    public static void invoke(Interpreter env, CallStack callstack) {
+        try {
+
+            LOGGER.warn("Clearing current state...");
+            env.eval("clear()");
+
+            LOGGER.warn("Loading internal commands...");
+            env.eval("importCommands(\"net.minecraft.client.console.shell.commands\")");
+            env.eval("importCommands(\"scripts.beanshell.commands\")");
+
+            LOGGER.warn("Loading external commands...");
+            File[] externalCommands = new File(Minecraft.getMinecraft().getMinecraftDir(), "/scripts/beanshell/commands").listFiles();
+            if (externalCommands != null) {
+                for (File file : externalCommands) {
+                    if (!file.getAbsolutePath().endsWith(".bsh")) continue;
+                    env.eval(("source(\"" + file.getAbsolutePath() + "\")").replace("\\", "/"));
+                }
+            }
+
+            LOGGER.warn("Loading internal scripts...");
+            String[] internalFiles = getFilesInDirectory("/scripts/beanshell/");
+            for (String file : internalFiles) {
+                if (!file.endsWith(".bsh")) continue;
+                env.eval("source(\"" + file.replace("/", ".") + "\")");
+            }
+
+            LOGGER.warn("Loading external scripts...");
+            File[] externalFiles = new File(Minecraft.getMinecraft().getMinecraftDir(), "/scripts/beanshell/").listFiles();
+            if (externalFiles != null) {
+                for (File file : externalFiles) {
+                    if (!file.getAbsolutePath().endsWith(".bsh")) continue;
+                    env.eval(("source(\"" + file.getAbsolutePath() + "\")").replace("\\", "/"));
+                }
+            }
+
+            LOGGER.info("Loaded commands and scripts.");
+        } catch (Exception e) {
+            LOGGER.error("Caught exception:", e);
+            LOGGER.error("Could not reload scripts!");
+        }
+    }
+
+    private static String[] getFilesInDirectory(String directory)
+    {
+        List<String> paths = new ArrayList<>();
+
+        if (!directory.endsWith("/")) directory = directory + "/";
+
+        label: try
+        {
+            URL url = TexturePack.class.getResource(directory);
+            if (url == null) break label;
+            URI uri = url.toURI();
+            Path myPath;
+            FileSystem fileSystem = null;
+            if (uri.getScheme().equals("jar"))
+            {
+                try
+                {
+                    fileSystem = FileSystems.getFileSystem(uri);
+                }
+                catch (Exception e)
+                {
+                    fileSystem = FileSystems.newFileSystem(uri, Collections.emptyMap());
+                }
+                myPath = fileSystem.getPath(directory);
+            }
+            else
+            {
+                myPath = Paths.get(uri);
+            }
+            try (Stream<Path> walk = Files.walk(myPath, 1))
+            {
+                Iterator<Path> it = walk.iterator();
+                it.next();
+                while(it.hasNext())
+                {
+                    paths.add(directory + it.next().getFileName().toString());
+                }
+            }
+            if (fileSystem != null)
+            {
+                fileSystem.close();
+            }
+        }
+        catch (Exception e)
+        {
+            LOGGER.error("Exception while loading all files in directory '{}'!", directory, e);
+        }
+
+        return paths.toArray(new String[0]);
+    }
+
+}
